# Bazaar merge directive format 2 (Bazaar 0.90)
# revision_id: colin@gibibit.com-20090615143625-5mw3hbalmw1vbbxl
# target_branch: http://grub.gibibit.com/bzr/trunk-clean
# testament_sha1: 54ff4c41df941b80a7d0190feb00b93953d814c9
# timestamp: 2009-06-15 07:41:27 -0700
# source_branch: http://grub.gibibit.com/bzr/gfxmenu
# base_revision_id: colin@gibibit.com-20090615143527-aecd7xrtc3v0vcfs
# 
# Begin patch
=== modified file 'commands/videotest.c'
--- commands/videotest.c	2009-06-04 17:22:45 +0000
+++ commands/videotest.c	2009-06-08 06:46:58 +0000
@@ -1,6 +1,6 @@
 /*
  *  GRUB  --  GRand Unified Bootloader
- *  Copyright (C) 2006,2007,2009  Free Software Foundation, Inc.
+ *  Copyright (C) 2006,2007,2008,2009  Free Software Foundation, Inc.
  *
  *  GRUB is free software: you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -16,38 +16,67 @@
  *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
  */
 
+#include <grub/time.h>
 #include <grub/video.h>
 #include <grub/types.h>
 #include <grub/dl.h>
+#include <grub/extcmd.h>
 #include <grub/misc.h>
 #include <grub/mm.h>
 #include <grub/font.h>
 #include <grub/term.h>
-#include <grub/command.h>
-
-static grub_err_t
-grub_cmd_videotest (grub_command_t cmd __attribute__ ((unused)),
-                    int argc __attribute__ ((unused)),
-                    char **args __attribute__ ((unused)))
-{
-  if (grub_video_set_mode ("1024x768;800x600;640x480", 0) != GRUB_ERR_NONE)
-    return grub_errno;
-
+#include <grub/bitmap.h>
+#include <grub/bitmap_scale.h>
+#include <grub/machine/vbe.h>   /* to test grub_vbe_bios_set_display_start */
+
+/* Option array indices.  */
+#define ARGINDEX_TEST_TIME 0
+#define ARGINDEX_DOUBLE_BUF 1
+
+static const struct grub_arg_option arg_options[] = {
+  {"time", 't', 0, "Time to run each test, in seconds.", 0, ARG_TYPE_INT},
+  {"dbuf", 'd', 0, "Use double buffered graphics.", 0, ARG_TYPE_NONE},
+  {0, 0, 0, 0, 0, 0}
+};
+
+#define DEFAULT_TEST_TIME 5
+
+/* Command options -- populated base on command line arguments.  */
+struct videotest_options
+{
+  int test_time;
+  int double_buffering;
+};
+
+/* List of video modes to try when an exact resolution is not required.  */
+static const char preferred_mode_list[] = "1024x768;800x600;640x480";
+
+static void
+basic_video_test (struct videotest_options *vt_opts)
+{
   grub_video_color_t color;
+  grub_video_color_t bg;
   unsigned int x;
   unsigned int y;
   unsigned int width;
   unsigned int height;
   int i;
-  grub_font_t sansbig;
-  grub_font_t sans;
-  grub_font_t sanssmall;
-  grub_font_t fixed;
   struct grub_font_glyph *glyph;
   struct grub_video_render_target *text_layer;
+  grub_font_t fixed;
   grub_video_color_t palette[16];
-  const char *str;
-  int texty;
+  int info_width;
+  int info_height;
+
+  if (grub_video_set_mode (preferred_mode_list, 0) != GRUB_ERR_NONE)
+    return;
+  grub_video_enable_double_buffering (vt_opts->double_buffering);
+
+  if (! (fixed = grub_font_get ("Fixed Regular 20")))
+    {
+      grub_error (GRUB_ERR_BAD_FONT, "No font loaded.");
+      return;
+    }
 
   grub_video_get_viewport (&x, &y, &width, &height);
 
@@ -57,7 +86,11 @@
 
   grub_video_set_active_render_target (GRUB_VIDEO_RENDER_TARGET_DISPLAY);
 
+  info_width = 500;
+  info_height = 100;
+
   color = grub_video_map_rgb (0, 0, 0);
+  bg = color;
   grub_video_fill_rect (color, 0, 0, width, height);
 
   color = grub_video_map_rgb (255, 0, 0);
@@ -66,13 +99,6 @@
   color = grub_video_map_rgb (0, 255, 255);
   grub_video_fill_rect (color, 100, 100, 100, 100);
 
-  sansbig = grub_font_get ("Helvetica Bold 24");
-  sans = grub_font_get ("Helvetica Bold 14");
-  sanssmall = grub_font_get ("Helvetica 8");
-  fixed = grub_font_get ("Fixed 20");
-  if (! sansbig || ! sans || ! sanssmall || ! fixed)
-    return grub_error (GRUB_ERR_BAD_FONT, "No font loaded.");
-
   glyph = grub_font_get_glyph (fixed, '*');
   grub_font_draw_glyph (glyph, color, 200 ,0);
 
